grk::Subband Struct Reference

`#include <Subband.h>`

Inheritance diagram for grk::Subband:

## Public Member Functions

| Subband ()
| Subband (const Subband &rhs)
virtual | ~Subband ()=default
Subband & | operator= (const Subband &rhs)
void | print () const override
bool | empty ()
Precinct * | getPrecinct (uint64_t precinctIndex)
grk_rect32 | generatePrecinctBounds (uint64_t precinctIndex, grk_pt32 precinctPartitionTopLeft, grk_pt32 precinctExpn, uint32_t precinctGridWidth)
Precinct * | createPrecinct (TileProcessor *tileProcessor, uint64_t precinctIndex, grk_pt32 precinctPartitionTopLeft, grk_pt32 precinctExpn, uint32_t precinctGridWidth, grk_pt32 cblk_expn)
Public Member Functions inherited from grk::grk_rect< uint32_t >
| grk_rect (uint32_t origin_x0, uint32_t origin_y0, uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (uint32_t x0, uint32_t y0, uint32_t x1, uint32_t y1)
| grk_rect (const grk_rect &rhs)
| grk_rect (const grk_rect *rhs)
| grk_rect (void)
virtual | ~grk_rect ()=default
grk_rect< uint32_t > & | setOrigin (uint32_t origx, uint32_t origy, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > &rhs, bool absolute)
grk_rect< uint32_t > & | setOrigin (grk_rect< uint32_t > *rhs, bool absolute)
grk_rect< uint32_t > & | toRelative (void)
grk_rect< uint32_t > & | toAbsolute (void)
std::string | boundsString () const
bool | valid (void) const
bool | empty (void) const
bool | contains (grk_pt< uint32_t > pt)
bool | contains (uint32_t x, uint32_t y)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > &rhs)
grk_rect< uint32_t > & | operator= (const grk_rect< uint32_t > *rhs)
bool | operator== (const grk_rect< uint32_t > &rhs) const
void | setRect (grk_rect< uint32_t > *rhs)
void | setRect (grk_rect< uint32_t > rhs)
grk_rect< uint32_t > | scaleDownCeil (uint32_t den) const
grk_rect< uint32_t > | scaleDownCeil (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scale (uint32_t scalex, uint32_t scaley) const
grk_rect< uint32_t > | scaleDown (uint64_t denx, uint64_t deny) const
grk_rect< uint32_t > | scaleDownPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | scaleDownPow2 (grk_pt< uint32_t > pow) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t power) const
grk_rect< uint32_t > | scaleDownCeilPow2 (uint32_t powx, uint32_t powy) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | intersection (const grk_rect< uint32_t > *rhs) const
bool | isContainedIn (const grk_rect< uint32_t > rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | clip (const grk_rect< uint32_t > &rhs) const
grk_rect< uint32_t > & | clip_IN_PLACE (const grk_rect< uint32_t > &rhs)
bool | nonEmptyIntersection (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > *rhs) const
grk_rect< uint32_t > | rectUnion (const grk_rect< uint32_t > &rhs) const
uint64_t | area (void) const
uint32_t | width () const
uint32_t | height () const
grk_line< uint32_t > | dimX () const
grk_line< uint32_t > | dimY () const
grk_rect< uint32_t > | pan (int64_t x, int64_t y) const
grk_rect< uint32_t > & | pan_IN_PLACE (int64_t x, int64_t y)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, uint32_t maxX, uint32_t maxY)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundary, grk_rect< uint32_t > bounds)
grk_rect< uint32_t > & | grow_IN_PLACE (uint32_t boundaryx, uint32_t boundaryy, grk_rect< uint32_t > bounds)
uint32_t | parityX (void) const
uint32_t | parityY (void) const

## Public Attributes

eBandOrientation | orientation
std::vector< Precinct * > | precincts
std::map< uint64_t, uint64_t > | precinctMap
uint64_t | numPrecincts
uint8_t | numbps
float | stepsize
Public Attributes inherited from grk::grk_rect< uint32_t >
bool | absoluteCoordinates
uint32_t | origin_x0
uint32_t | origin_y0
uint32_t | x0
uint32_t | y0
uint32_t | x1
uint32_t | y1

## Constructor & Destructor Documentation

## Subband() [1/2]

grk::Subband::Subband | ( |  | ) |

Referenced by operator=().

## Subband() [2/2]

grk::Subband::Subband | ( | const Subband & | rhs | ) |

## ~Subband()

virtual grk::Subband::~Subband | ( |  | ) |

virtual default

## Member Function Documentation

## createPrecinct()

Precinct * grk::Subband::createPrecinct | ( | TileProcessor * | tileProcessor,
|  | uint64_t | precinctIndex,
|  | grk_pt32 | precinctPartitionTopLeft,
|  | grk_pt32 | precinctExpn,
|  | uint32_t | precinctGridWidth,
|  | grk_pt32 | cblk_expn
| ) |  |

References generatePrecinctBounds(), grk::GRK_ERROR(), grk::grk_read(), precinctMap, and precincts.

## empty()

bool grk::Subband::empty | ( | void |  | ) |

References grk::grk_rect< uint32_t >::x0, grk::grk_rect< uint32_t >::x1, grk::grk_rect< uint32_t >::y0, and grk::grk_rect< uint32_t >::y1.

## generatePrecinctBounds()

grk_rect32 grk::Subband::generatePrecinctBounds | ( | uint64_t | precinctIndex,
|  | grk_pt32 | precinctPartitionTopLeft,
|  | grk_pt32 | precinctExpn,
|  | uint32_t | precinctGridWidth
| ) |  |

References grk::grk_read(), grk::grk_rect< T >::intersection(), grk::grk_pt< T >::x, and grk::grk_pt< T >::y.

Referenced by createPrecinct().

## getPrecinct()

Precinct * grk::Subband::getPrecinct | ( | uint64_t | precinctIndex | ) |

References grk::grk_read(), precinctMap, and precincts.

Referenced by grk::PacketParser::readData().

## operator=()

Subband & grk::Subband::operator= | ( | const Subband & | rhs | ) |

References grk::grk_read(), and Subband().

## print()

void grk::Subband::print | ( | void |  | ) | const

override virtual

Reimplemented from grk::grk_rect< uint32_t >.

References grk::grk_rect< uint32_t >::print().

Referenced by grk::Resolution::print().

## Member Data Documentation

## numbps

uint8_t grk::Subband::numbps

## numPrecincts

uint64_t grk::Subband::numPrecincts

Referenced by grk::Resolution::init().

## orientation

eBandOrientation grk::Subband::orientation

## precinctMap

std::map<uint64_t, uint64_t> grk::Subband::precinctMap

Referenced by createPrecinct(), and getPrecinct().

## precincts

std::vector<Precinct*> grk::Subband::precincts

Referenced by createPrecinct(), getPrecinct(), and grk::TileComponent::~TileComponent().

## stepsize

float grk::Subband::stepsize

Referenced by grk::compress_synch_with_plugin().

The documentation for this struct was generated from the following files:

- Subband.h
- Subband.cpp